Skip to content

Introduction

The Hypatos API is organized around REST. The majority of the endpoints provide CRUD functionality for resources. The API is also exposing Intent Resources which mimic user intents or actions.

The Hypatos API uses OAuth 2.0 Client Credential Grant to authenticate requests. Before making any requests to any endpoint a client must authenticate with the authorization server and requests an access token from the token endpoint.

  POST /auth/token HTTP/1.1
  Host: api.cloud.hypatos.ai
  Content-Type: application/x-www-form-urlencoded
  Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=

  grant_type=client_credentials

Authorization header contains client_id:client_secret encoded as explained in RFC Client Password section.

If the authorization server authenticated the client successfully, an access token is issued. Here is an example successful response:

  HTTP/1.1 200 OK
  Content-Type: application/json;charset=UTF-8
  Cache-Control: no-store
  Pragma: no-cache

  {
    "access_token": "mF_9.B5f-4.1JqM",
    "expires_in": 86400,
    "scope": "enrichment.write files.read",
    "token_type": "Bearer",
  }

This token can be used to authenticate the requests to API endpoints by sending a Bearer token in the Authorization HTTP header. The following example demonstrates how to use the access token to retrieve a list of documents.

  GET /v2/documents HTTP/1.1
  Host: api.cloud.hypatos.ai
  Authorization: Bearer mF_9.B5f-4.1JqM

Versioning

Changes to this API are released regularly. We use Semantic Versioning 2.0.0 scheme for versioning so that the clients can identify any backward-incompatible changes easily. Briefly summarized one can say, if the MAJOR version of the new API version didn't change you can expect the new version to be backward-compatible.

Rate limits

In order to maximise the stability of our API, we institue rate limits for all of API endpoints. Clients who send too many requests over a given period of time will see error responses that show up as status code 429 Too Many Requests.

When you see error responses with status code 429, it means you exhausted your current quota and need to withhold from sending further requests until the quota is reset. We encourage you not to wait until you get a 429 error but to monitor your quota in each request. In each response you receive from the API, you will find HTTP headers providing the details about your current quota. Here is the list of the HTTP headers:

  • x-ratelimit-limit: Indicates the quota associated to the client in the current time-window followed by the description of the quota policy.
  • x-ratelimit-remaining: Indicates the number of remaining requests in the current time-window
  • x-ratelimit-reset: Indicates the number of seconds until quota reset of the current time-window

Please note that IETF is currently in the process of publishing a standard for these headers. Please explore the draft for more details.

A basic technique to gracefully handle rate limits is watch for your quota permanently and increase the time between your request as the quota is decreasing. To recover from a 429 error you need a retry mechanism following an exponential backoff schedule.

Download OpenAPI description
Overview
License
Languages
Servers
API EU
https://api.cloud.hypatos.ai/v2
API US
https://api.cloud.hypatos.com/v2
Mock server
https://hypatos.redocly.app/_mock/openapi
Operations

Endpoints for management of files

Operations

Endpoints for document management

Operations

Endpoints for data enrichment

Operations

Request

Security
OAuth2(Required scopes:
enrichment.delete
)
Path
externalIdstringrequired

Previously sent externalId

curl -i -X DELETE \
  'https://api.cloud.hypatos.ai/v2/enrichment/addresses/{externalId}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'

Responses

Successfully deleted

Response
No content

Request

Security
OAuth2(Required scopes:
enrichment.write
)
Bodyapplication/jsonrequired
externalIdstring^\S+$required

External id of the sales order that is globally unique across the provided sales order data

Example: "QUOTE12345"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "CLIENT123"
documentIdstring

Document id that was assigned during upload to Hypatos

Example: "DOC12345"
documentsArray of objects
quoteNumberstring

Quote number from the source system

Example: "Q12345"
customerOrderNumberstring

Customer order number the quote refers to

Example: "CO12345"
externalCompanyIdstring

External unique id of the company in the source system

Example: "COMP123"
externalCustomerIdstring

External unique id of the customer in the source system

Example: "CUST123"
statusstring

Status of the quote

Example: "approved"
salesOrganizationCodestring

Sales organization code

Example: "SO123"
distributionChannelstring

Distribution channel code

Example: "DC123"
divisionstring

Division code

Example: "DIV123"
salesGroupstring

Sales group responsible for the quote

Example: "123"
salesOfficestring

Sales office responsible for the quote

Example: "456"
typestring

Type of the quote as defined in the source system

Example: "standard"
subTypestring

Sub-type of the quote as defined in the source system

Example: "recurring"
issuedDatestring(date)

Date when the quote was issued

Example: "2023-01-01"
validUntilDatestring(date)

Date until the quote is valid

Example: "2023-12-31"
fiscalYearLabelstring

Fiscal year label used in the source system

Example: "FY2023"
isCanceledboolean

Indicator if the quote is canceled

Example: false
currencystring

Three letter currency code as defined in ISO 4217

Example: "USD"
totalNetAmountnumber

Total net amount of the quote

Example: 1000
totalTaxAmountnumber

Total tax amount of the quote

Example: 190
totalGrossAmountnumber

Total gross amount of the quote

Example: 1190
paymentTermsobject(paymentTerms)
headerTextstring

Header text describing the quote

Example: "This is a sample quote."
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
quoteLinesArray of objects
curl -i -X POST \
  https://api.cloud.hypatos.ai/v2/enrichment/quotes \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "externalId": "QUOTE12345",
    "externalClientId": "CLIENT123",
    "documentId": "DOC12345",
    "documents": [
      {
        "id": "DOC12345",
        "type": "invoice"
      }
    ],
    "quoteNumber": "Q12345",
    "customerOrderNumber": "CO12345",
    "externalCompanyId": "COMP123",
    "externalCustomerId": "CUST123",
    "status": "approved",
    "salesOrganizationCode": "SO123",
    "distributionChannel": "DC123",
    "division": "DIV123",
    "salesGroup": "123",
    "salesOffice": "456",
    "type": "standard",
    "subType": "recurring",
    "issuedDate": "2023-01-01",
    "validUntilDate": "2023-12-31",
    "fiscalYearLabel": "FY2023",
    "isCanceled": false,
    "currency": "USD",
    "totalNetAmount": 1000,
    "totalTaxAmount": 190,
    "totalGrossAmount": 1190,
    "paymentTerms": {
      "paymentTermKey": "T10",
      "descriptions": [
        {
          "text": "Please pay us",
          "language": "en"
        }
      ]
    },
    "headerText": "This is a sample quote.",
    "customFields": {
      "property1": "string",
      "property2": "string"
    },
    "customMetadata": {
      "someTopLevelProperty": "value1",
      "someNestedProperty": {
        "nestedProperty": "value2"
      },
      "someArrayProperty": [
        "value3",
        "value4"
      ]
    },
    "quoteLines": [
      {
        "quoteLineNumber": "QL12345",
        "externalCompanyId": "COMP123",
        "product": {
          "externalId": "PROD123",
          "productNumber": "PN123",
          "customerProductNumber": "CPN123",
          "type": "standard",
          "group": "electronics",
          "description": "A high-quality electronic product.",
          "manufacturer": "Acme Corp.",
          "manufacturerNumber": "MN123",
          "unspsc": "43211508",
          "ean": "4006381333931",
          "upc": "036000291452"
        },
        "status": "approved",
        "quantity": 10,
        "unitOfMeasure": "kg",
        "unitPrice": 100,
        "netAmount": 1000,
        "totalTaxAmount": 190,
        "grossAmount": 1190,
        "taxCode": {
          "code": "DEU_Standard",
          "description": "DEU - Standard (19%)"
        },
        "description": "This is a sample quote line.",
        "plant": "PLANT123",
        "storageLocation": "LOC123",
        "externalShippingAddressId": "ADDR123",
        "externalBillingAddressId": "ADDR456",
        "itemText": "Sample item text.",
        "type": "standard",
        "externalContractId": "CONTRACT123",
        "customFields": {
          "property1": "string",
          "property2": "string"
        },
        "customMetadata": {
          "someTopLevelProperty": "value1",
          "someNestedProperty": {
            "nestedProperty": "value2"
          },
          "someArrayProperty": [
            "value3",
            "value4"
          ]
        }
      }
    ]
  }'

Responses

Successfully inserted

Bodyapplication/json
idstringrequired
Example: "3a429dc8-56d4-42ef-a4cf-2ebc9ad1ef38"
Response
application/json
{ "id": "3a429dc8-56d4-42ef-a4cf-2ebc9ad1ef38" }

Request

Security
OAuth2(Required scopes:
enrichment.write
)
Path
externalIdstringrequired

Previously sent externalId

Bodyapplication/merge-patch+jsonrequired
externalIdstring^\S+$required

External id of the sales order that is globally unique across the provided sales order data

Example: "QUOTE12345"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "CLIENT123"
documentIdstring

Document id that was assigned during upload to Hypatos

Example: "DOC12345"
documentsArray of objects
quoteNumberstring

Quote number from the source system

Example: "Q12345"
customerOrderNumberstring

Customer order number the quote refers to

Example: "CO12345"
externalCompanyIdstring

External unique id of the company in the source system

Example: "COMP123"
externalCustomerIdstring

External unique id of the customer in the source system

Example: "CUST123"
statusstring

Status of the quote

Example: "approved"
salesOrganizationCodestring

Sales organization code

Example: "SO123"
distributionChannelstring

Distribution channel code

Example: "DC123"
divisionstring

Division code

Example: "DIV123"
salesGroupstring

Sales group responsible for the quote

Example: "123"
salesOfficestring

Sales office responsible for the quote

Example: "456"
typestring

Type of the quote as defined in the source system

Example: "standard"
subTypestring

Sub-type of the quote as defined in the source system

Example: "recurring"
issuedDatestring(date)

Date when the quote was issued

Example: "2023-01-01"
validUntilDatestring(date)

Date until the quote is valid

Example: "2023-12-31"
fiscalYearLabelstring

Fiscal year label used in the source system

Example: "FY2023"
isCanceledboolean

Indicator if the quote is canceled

Example: false
currencystring

Three letter currency code as defined in ISO 4217

Example: "USD"
totalNetAmountnumber

Total net amount of the quote

Example: 1000
totalTaxAmountnumber

Total tax amount of the quote

Example: 190
totalGrossAmountnumber

Total gross amount of the quote

Example: 1190
paymentTermsobject(paymentTerms)
headerTextstring

Header text describing the quote

Example: "This is a sample quote."
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
quoteLinesArray of objects
curl -i -X PATCH \
  'https://api.cloud.hypatos.ai/v2/enrichment/quotes/{externalId}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Type: application/merge-patch+json' \
  -d '{
    "externalId": "QUOTE12345",
    "externalClientId": "CLIENT123",
    "documentId": "DOC12345",
    "documents": [
      {
        "id": "DOC12345",
        "type": "invoice"
      }
    ],
    "quoteNumber": "Q12345",
    "customerOrderNumber": "CO12345",
    "externalCompanyId": "COMP123",
    "externalCustomerId": "CUST123",
    "status": "approved",
    "salesOrganizationCode": "SO123",
    "distributionChannel": "DC123",
    "division": "DIV123",
    "salesGroup": "123",
    "salesOffice": "456",
    "type": "standard",
    "subType": "recurring",
    "issuedDate": "2023-01-01",
    "validUntilDate": "2023-12-31",
    "fiscalYearLabel": "FY2023",
    "isCanceled": false,
    "currency": "USD",
    "totalNetAmount": 1000,
    "totalTaxAmount": 190,
    "totalGrossAmount": 1190,
    "paymentTerms": {
      "paymentTermKey": "T10",
      "descriptions": [
        {
          "text": "Please pay us",
          "language": "en"
        }
      ]
    },
    "headerText": "This is a sample quote.",
    "customFields": {
      "property1": "string",
      "property2": "string"
    },
    "customMetadata": {
      "someTopLevelProperty": "value1",
      "someNestedProperty": {
        "nestedProperty": "value2"
      },
      "someArrayProperty": [
        "value3",
        "value4"
      ]
    },
    "quoteLines": [
      {
        "quoteLineNumber": "QL12345",
        "externalCompanyId": "COMP123",
        "product": {
          "externalId": "PROD123",
          "productNumber": "PN123",
          "customerProductNumber": "CPN123",
          "type": "standard",
          "group": "electronics",
          "description": "A high-quality electronic product.",
          "manufacturer": "Acme Corp.",
          "manufacturerNumber": "MN123",
          "unspsc": "43211508",
          "ean": "4006381333931",
          "upc": "036000291452"
        },
        "status": "approved",
        "quantity": 10,
        "unitOfMeasure": "kg",
        "unitPrice": 100,
        "netAmount": 1000,
        "totalTaxAmount": 190,
        "grossAmount": 1190,
        "taxCode": {
          "code": "DEU_Standard",
          "description": "DEU - Standard (19%)"
        },
        "description": "This is a sample quote line.",
        "plant": "PLANT123",
        "storageLocation": "LOC123",
        "externalShippingAddressId": "ADDR123",
        "externalBillingAddressId": "ADDR456",
        "itemText": "Sample item text.",
        "type": "standard",
        "externalContractId": "CONTRACT123",
        "customFields": {
          "property1": "string",
          "property2": "string"
        },
        "customMetadata": {
          "someTopLevelProperty": "value1",
          "someNestedProperty": {
            "nestedProperty": "value2"
          },
          "someArrayProperty": [
            "value3",
            "value4"
          ]
        }
      }
    ]
  }'

Responses

Successfully updated

Bodyapplication/json
externalIdstring^\S+$required

External id of the sales order that is globally unique across the provided sales order data

Example: "QUOTE12345"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "CLIENT123"
documentIdstring

Document id that was assigned during upload to Hypatos

Example: "DOC12345"
documentsArray of objects
quoteNumberstring

Quote number from the source system

Example: "Q12345"
customerOrderNumberstring

Customer order number the quote refers to

Example: "CO12345"
externalCompanyIdstring

External unique id of the company in the source system

Example: "COMP123"
externalCustomerIdstring

External unique id of the customer in the source system

Example: "CUST123"
statusstring

Status of the quote

Example: "approved"
salesOrganizationCodestring

Sales organization code

Example: "SO123"
distributionChannelstring

Distribution channel code

Example: "DC123"
divisionstring

Division code

Example: "DIV123"
salesGroupstring

Sales group responsible for the quote

Example: "123"
salesOfficestring

Sales office responsible for the quote

Example: "456"
typestring

Type of the quote as defined in the source system

Example: "standard"
subTypestring

Sub-type of the quote as defined in the source system

Example: "recurring"
issuedDatestring(date)

Date when the quote was issued

Example: "2023-01-01"
validUntilDatestring(date)

Date until the quote is valid

Example: "2023-12-31"
fiscalYearLabelstring

Fiscal year label used in the source system

Example: "FY2023"
isCanceledboolean

Indicator if the quote is canceled

Example: false
currencystring

Three letter currency code as defined in ISO 4217

Example: "USD"
totalNetAmountnumber

Total net amount of the quote

Example: 1000
totalTaxAmountnumber

Total tax amount of the quote

Example: 190
totalGrossAmountnumber

Total gross amount of the quote

Example: 1190
paymentTermsobject(paymentTerms)
headerTextstring

Header text describing the quote

Example: "This is a sample quote."
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
quoteLinesArray of objects
Response
application/json
{ "externalId": "QUOTE12345", "externalClientId": "CLIENT123", "documentId": "DOC12345", "documents": [ { … } ], "quoteNumber": "Q12345", "customerOrderNumber": "CO12345", "externalCompanyId": "COMP123", "externalCustomerId": "CUST123", "status": "approved", "salesOrganizationCode": "SO123", "distributionChannel": "DC123", "division": "DIV123", "salesGroup": "123", "salesOffice": "456", "type": "standard", "subType": "recurring", "issuedDate": "2023-01-01", "validUntilDate": "2023-12-31", "fiscalYearLabel": "FY2023", "isCanceled": false, "currency": "USD", "totalNetAmount": 1000, "totalTaxAmount": 190, "totalGrossAmount": 1190, "paymentTerms": { "paymentTermKey": "T10", "descriptions": [ … ] }, "headerText": "This is a sample quote.", "customFields": { "property1": "string", "property2": "string" }, "customMetadata": { "someTopLevelProperty": "value1", "someNestedProperty": { … }, "someArrayProperty": [ … ] }, "quoteLines": [ { … } ] }

Endpoints for company management

Operations

Endpoints for project management

Operations

Endpoints for e-invoices

Operations

Endpoints serving project-scoped documents as XML

Operations
Operations
Operations
Operations